QT       += core gui axcontainer

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

CONFIG += c++11

win32:CONFIG(release, debug|release){
    DESTDIR = ../bin/release
}
else:win32:CONFIG(debug, debug|release){
    DESTDIR = ../bin/debug
}
# You can make your code fail to compile if it uses deprecated APIs.
# In order to do so, uncomment the following line.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0

SOURCES += \
    entity/Airport.cpp \
    forms/AirportWidget.cpp \
    main.cpp \
    mainwindow.cpp \
    models/AirportModel.cpp \
    models/ModelBase.cpp \
    models/OrmModelBase.cpp \
    services/AirportService.cpp \
    services/Application.cpp \
    services/ApplicationConfigurator.cpp \
    services/DatabaseConnector.cpp \
    services/Dict.cpp \
    services/ServiceBase.cpp \
    utils/DoubleValidator.cpp \
    utils/FormBuilder.cpp \
    utils/IxWidgetUtil.cpp \
    utils/SqlGenerator_Oracle.cpp \
    utils/WzExcel.cpp \
    widgets/AdvancedTableView.cpp \
    widgets/CustomDelegate.cpp \
    widgets/DialogTemplate.cpp \
    widgets/FramelessHelper.cpp \
    widgets/IxWidgets/AutoCompleteComBoxWidget.cpp \
    widgets/IxWidgets/AutoCompleteTagEditWidget.cpp \
    widgets/IxWidgets/CheckComboBoxWidget.cpp \
    widgets/IxWidgets/ComboBoxWidget.cpp \
    widgets/IxWidgets/DateTimeWidget.cpp \
    widgets/IxWidgets/LineEditWidget.cpp \
    widgets/IxWidgets/PathSelectorWidget.cpp \
    widgets/IxWidgets/TagEditWidget.cpp \
    widgets/MultipleTableView.cpp \
    widgets/Pagination.cpp \
    widgets/TabPage.cpp \
    widgets/TableView.cpp \
    widgets/Tag.cpp \
    widgets/TagEdit.cpp \
    widgets/TitleBar.cpp \
    widgets/WidgetFactorys/AutoCompleteComBoxWidgetFactory.cpp \
    widgets/WidgetFactorys/AutoCompleteTagEditWidgetFactory.cpp \
    widgets/WidgetFactorys/CheckComboBoxWidgetFactory.cpp \
    widgets/WidgetFactorys/ComboBoxWidgetFactory.cpp \
    widgets/WidgetFactorys/DateTimeWidgetFactory.cpp \
    widgets/WidgetFactorys/LineEditWidgetFactory.cpp \
    widgets/WidgetFactorys/PathSelectorWidgetFactory.cpp \
    widgets/WidgetFactorys/TagEditWidgetFactory.cpp \
    widgets/WidgetFactorys/WidgetFactory.cpp \
    widgets/WindowButtonGroup.cpp \
    widgets/loadingindicator.cpp

HEADERS += \
    entity/Airport.h \
    forms/AirportWidget.h \
    mainwindow.h \
    models/AirportModel.h \
    models/ModelBase.h \
    models/OrmModelBase.h \
    models/QxModelBase.h \
    services/AirportService.h \
    services/Application.h \
    services/ApplicationConfigurator.h \
    services/DatabaseConnector.h \
    services/Dict.h \
    services/ServiceBase.h \
    utils/DebugUtil.h \
    utils/DoubleValidator.h \
    utils/FormBuilder.h \
    utils/IxWidgetUtil.h \
    utils/MessageException.h \
    utils/SqlGenerator_Oracle.h \
    utils/WzExcel.h \
    utils/charcode.h \
    utils/regExp.h \
    utils/utils.h \
    widgets/AdvancedTableView.h \
    widgets/CustomDelegate.h \
    widgets/DialogTemplate.h \
    widgets/FramelessHelper.h \
    widgets/IxWidgets/AutoCompleteComBoxWidget.h \
    widgets/IxWidgets/AutoCompleteTagEditWidget.h \
    widgets/IxWidgets/CheckComboBoxWidget.h \
    widgets/IxWidgets/ComboBoxWidget.h \
    widgets/IxWidgets/DateTimeWidget.h \
    widgets/IxWidgets/IxWidget.h \
    widgets/IxWidgets/LineEditWidget.h \
    widgets/IxWidgets/PathSelectorWidget.h \
    widgets/IxWidgets/TagEditWidget.h \
    widgets/MultipleTableView.h \
    widgets/Pagination.h \
    widgets/TabPage.h \
    widgets/TableView.h \
    widgets/Tag.h \
    widgets/TagEdit.h \
    widgets/TitleBar.h \
    widgets/WidgetFactorys/AutoCompleteComBoxWidgetFactory.h \
    widgets/WidgetFactorys/AutoCompleteTagEditWidgetFactory.h \
    widgets/WidgetFactorys/CheckComboBoxWidgetFactory.h \
    widgets/WidgetFactorys/ComboBoxWidgetFactory.h \
    widgets/WidgetFactorys/DateTimeWidgetFactory.h \
    widgets/WidgetFactorys/IxWidgetFactory.h \
    widgets/WidgetFactorys/LineEditWidgetFactory.h \
    widgets/WidgetFactorys/PathSelectorWidgetFactory.h \
    widgets/WidgetFactorys/TagEditWidgetFactory.h \
    widgets/WidgetFactorys/WidgetFactory.h \
    widgets/WindowButtonGroup.h \
    widgets/loadingindicator.h

FORMS += \
    forms/AirportWidget.ui \
    mainwindow.ui

INCLUDEPATH += utils/ \
               forms/ \
               entity/ \
               models/ \
               services/ \
               widgets/ \
               widgets/IxWidgets/ \
               widgets/WidgetFactorys/

# Default rules for deployment.
qnx: target.path = /tmp/$${TARGET}/bin
else: unix:!android: target.path = /opt/$${TARGET}/bin
!isEmpty(target.path): INSTALLS += target


# QxOrm配置
DEFINES += _BUILDING_QXORM
include($$PWD/../libs/QxOrm/QxOrm.pri)

win32:CONFIG(release, debug|release): LIBS += -L$$PWD/../libs/QxOrm/lib/ -lQxOrm
else:win32:CONFIG(debug, debug|release): LIBS += -L$$PWD/../libs/QxOrm/lib/ -lQxOrmd

INCLUDEPATH += $$PWD/../libs/QxOrm/include
DEPENDPATH += $$PWD/../libs/QxOrm/include

RESOURCES += \
    MainWindow.qrc


